#include "stdafx.h"
#include "Socket.h"
#include "Client.h"
#include "time.h"

Client::Client(CDialog *dialog)
{
	pDialog = dialog;

	hClientStop = CreateEvent(NULL, FALSE, FALSE, NULL);	

	WORD wVersionRequested;
	WSADATA wsaData;
	wVersionRequested = MAKEWORD(2,0);

	if(WSAStartup( wVersionRequested, &wsaData ) != 0)
	{
		MessageBoxA(dialog->m_hWnd, "Chyba inicializcie 'Winsock DLL' ", "CHYBA", MB_OK);		
	}		
}

Client::~Client()
{			
	CloseHandle(hClientStop);
}

void Client::StartTCPClient()
{	
	hClientThread =(HANDLE)_beginthread(this->StartThread, 0, this);	
}


void Client::StopTCPClient()
{	
	SetEvent(hClientStop);							
}


void Client::StartThread(void *ts)
{
	Client *server = (Client *)ts;
	server->ConnectOnPort();
}

int Client::Set_sockaddr_in(const char* host, const char* service, const char* protocol, sockaddr_in* si)
{
	struct servent *pse;
	struct hostent *phe;
	
	memset(si, 0, sizeof(sockaddr_in)); //ZNUNUJEME SI 'si' STRUKTURU

	si->sin_family = AF_INET; //BUDEME POUZIVAT IP ADRESY PROTOKOLU IP PROTOKOLU 'IPv4'

	//ZISTIME CISLO PORTU PODLA POZADOVANEJ SLUZBY A PROTOKOLU
	if(service)
	{
		if((pse = getservbyname(service, protocol)) != 0)
		{
			si->sin_port = pse->s_port;
		}
		//TCP/IP SIETE POUZIVAJU OBRATENE PORADIE BAJTOV PRETO TO OTOCIME POMOCOU 'htons'
		else if((si->sin_port = htons((u_short)atoi(service))) == 0)
		{		
			return 1;//NASTALA CHYBA
		}
	}
		
	if(host)
	{
		//AK NEOBSAHUJE CISLA TJ. JE ZADANA SYMBOLICKY NAPR: 'tuke.sk'
		// POTOM ZAVOLAME 'gethostbyname' A DOSTANEME IP ADRESU DO 'phe' STRUKTURY
		if((host[0]<'0' || host[0]>'9') && ((phe = gethostbyname(host)) != 0))
		{
			//NAKOPIRUJEME SI ZISTENU IP ADRESU Z 'phe' STRUKTURY DO 'si' STRUKTURY
			memcpy(&si->sin_addr, phe->h_addr, phe->h_length);			
		}
		//AK JE IP ADRESA ZADANA CISELNE NAPR '10.1.1.195' 
		//TAK SKONVERTUJEME   RETAZEC '10.1.1.195' POMOCOU 'inet_addr' NA FORMAT POTREBNY PRE 'si' STRUKTURU
		//AK ADRESA OBSAHUJE BLUDY ...NAPR:  10.1.1.333 TAK DOSTANEME CHYBU 'INADDR_NONE' tj. NEJEDNA SA O IP ADRESU
		else if((si->sin_addr.s_addr = inet_addr(host)) == INADDR_NONE) 
		{		
			return 1;//NASTALA CHYBA
		}
	}
	return 0;
}


SOCKET Client::Connect(const char *host, const char *service)
{
	struct sockaddr_in si;
	struct protoent *ppe;
	SOCKET sock;	

	//NAPLNIME SI STRUKTURU 'si' PODLA ZADANEEJ ADRESY A PORTU	
	if(Set_sockaddr_in(host, service, "tcp", &si))
		return 0;

	//ZISTIME CISLO PROTOKOLU PODLA SYMBOLICKEHO MENA 'tcp'
	if((ppe = getprotobyname("tcp")) == 0)
	{		
		return NULL;//NASTALA CHYBA
	}

	//VYTOVRIME NOVY SOCKET PRE TCP PROTOKOL
	sock = socket(PF_INET, SOCK_STREAM, ppe->p_proto);

	if(sock == INVALID_SOCKET)
	{		
		return NULL;
	}
	
	//PRIPOJIME SOCKET 
	if(connect(sock,(const struct sockaddr *)&si,sizeof(si))!=0)
	{		
		closesocket(sock);
		return NULL;//nemoze sa spojit
	}

	return sock;
}

void Client::ConnectOnPort()
{	
	//NACITAME SI IP ADRESU A PORT KAM SA MA APLIKACIA PRIPOJIT
	CEdit *pAddress = (CEdit *)(pDialog->GetDlgItem(IDC_EDITIPADDRESS));
	CEdit *pPort = (CEdit *)(pDialog->GetDlgItem(IDC_PORT));

	char cIpAddress[16];
	char cPort[6];
	pAddress->GetWindowText(cIpAddress, sizeof(cIpAddress));
	pPort->GetWindowText(cPort, sizeof(cPort));

	if(strlen(cIpAddress) == 0)
	{
		MessageBoxA(pDialog->m_hWnd, "IP adresa nie je vyplnen.\nPouije sa 127.0.0.1", "CHYBA", MB_OK);		
		sprintf(cIpAddress, "127.0.0.1");
		pAddress->SetWindowText(cIpAddress);
	}

	if(strlen(cPort) == 0)
	{
		MessageBoxA(pDialog->m_hWnd, "Port nie je vyplnen.\nPouije sa 7777", "CHYBA", MB_OK);		
		sprintf(cPort, "7777");
		pPort->SetWindowText(cPort);
	}
		
	timeval tv;
	tv.tv_sec = 0;
	tv.tv_usec = 300000; //300 MILISEKUND TIMEOUT pre 'select' PRIKAZ 

	fd_set fdReadSet;
	fd_set fdCheckSet;

	FD_ZERO(&fdReadSet); //VYCISTIME SADU

	ResetEvent(hClientStop); //RESETUJEME EVENT ABY NEBOL NASTAVENY (NEMAL BY BYT)
	socketConnect = NULL;
	
	while(WaitForSingleObject(hClientStop, 0 ) == WAIT_TIMEOUT) //SK NASTANE EVENT CLIENT STOP tj. STLACENIE TLACIDLA STOP => VYSKOCIME  Z while()
	{
		if(socketConnect == NULL) //JE ESTE NEPRIPOJENY SOCKET 
		{
			if((socketConnect = this->Connect(cIpAddress, cPort)) != NULL) //SKUSIME PRIPOJIT
			{
				SendMessage(pDialog->m_hWnd, MSG_SERVER_UP, NULL, NULL);	 //AK SA PODARILO DAME VEDIET DIALOGU
				FD_SET(socketConnect, &fdReadSet); //VLOZIME HO DO SADY KTORU BUDEME KONROLOVAT NA PRICHODZIE DATA
			}
			else
			{	
				//AK SA NEPODARILO PRIPOJIT
				SendMessage(pDialog->m_hWnd, MSG_SERVER_DOWN, NULL, NULL);	//DAME VEDIET DIALOGU
				FD_CLR(socketConnect, &fdReadSet); //ODSTRANIME HO ZO SADY
				closesocket(socketConnect); //UROBIME CLOSE SOCKET
				socketConnect = NULL; //ZNULUJEME HO 
				Sleep(5000); //POCKAME 5 SEKUND
				continue; // A OROCIME SA VO WHILE KDE SA ZNOVU SKUSIME PRIPOJIT
			}
		}

		memcpy(&fdCheckSet, &fdReadSet, sizeof(fdCheckSet)); //UROBIME SI KOPIU SADY NAD KTOROU ZAVOLAME POTOM 'select'
		
		select(0, &fdCheckSet, NULL, NULL, &tv); 
				
		if(fdCheckSet.fd_count == 0) //SIGNALIZOVAL SOCKET UDALOST ?? AK NIE => fd_count == 0  TAK SA OTOCIME VO WHILE A ZNOVU SKUSIME o 300 MILISEKUND 'select'
			continue;

		memset(cSocketBuffer, 0, sizeof(cSocketBuffer));	//VYCISTIME BUFFER

		int iBytesReceived = recv(socketConnect, cSocketBuffer, sizeof(cSocketBuffer), 0); //NACITAME ZO SOKETU

		if(iBytesReceived == SOCKET_ERROR || iBytesReceived == 0) //CHYBA NA SOCKETE == 'SOCKET_ERROR' ALEBO ODPOJENIE KLIENTA == '0' 
		{			
			SendMessage(pDialog->m_hWnd, MSG_SERVER_DOWN, NULL, NULL);		//DAME VEDIET DIALOGU									
			closesocket(socketConnect);		
			socketConnect = NULL;
			continue;		
		}
		else
		{				
			SendMessage(pDialog->m_hWnd, MSG_NEW_DATA, NULL, NULL);	 //DAME VEDIET DIALOGU ZE SU NOVE DATA A ON SI ICH VYZDVIHNE Z BUFFERA
		}		
	}

	//AK BOLO STLACENE 'STOP' TLACIDLO TAK VYSKOCIME Z while() A ZAVRIEME SKOCKET A VLAKNO SA SKONCI
	closesocket(socketConnect);
}

//PUBLIC METODA KTORA UMOZNI DIALOGU VYBRAT DATA Z BUFFERA DO KTOREHO SA ULOZILI DATA NACITANE ZO SOCKETU
//DIALOG POSKYTNE BUFFER a 'Client' OBJEKT MU DATA DO NEHO NAKOPIRUJE
void Client::GetSocketBuffer(char *cBuffer, int iBufferSize) 
{	
	strcpy_s(cBuffer, iBufferSize, cSocketBuffer);
}

//METODA NA ODOSLANIE DAT CEZ SOCKET
void Client::SendData(char *cBuffer, int iDataLength)
{
	send(socketConnect, cBuffer, iDataLength, 0);
}
