#include "stdafx.h"
//#include "Log.h"
#include "Socket.h"

// #ifdef _DEBUG
// #define new DEBUG_NEW
// #undef THIS_FILE
// static char THIS_FILE[] = __FILE__;
// #endif

#ifndef OK
#define OK		0
#define CHYBA	1
#endif

int Socket::init=0;

//skopiruje socket
Socket::Socket(Socket *ts)
{
	s1=0;
	s=ts->s;
	InitSockets();
}

Socket::Socket(void)
{
	s=0;s1=0;
	InitSockets();
}

Socket::~Socket(void)
{
	CloseSocketS();
	CloseSocketS1();
}

void Socket::InitSockets(void)//inicializuje pripojenie WinSock dll kniznice
{
	if(!init){
		//Ma vyznam len vtedy, ak MFC neinicializuju WinSock
		WORD wVersionRequested;
		WSADATA wsaData;
		wVersionRequested = MAKEWORD(2,0);
		if(!WSAStartup( wVersionRequested, &wsaData )){
			init=1;
		}
		else{
			init=0;
#ifdef _DEBUG
//		::MessageBox(GetDesktopWindow(),"Chyba pri inicializovan socket-ov!", SERVICE_NAME, MB_ICONWARNING);
#endif
		}
	}
}

int Socket::FreeSockets(void)
{
	return WSACleanup(); 
}

void Socket::CloseSocketS(void)
{
	if(s){
		int rc = closesocket(s);
		s = 0;
		//g_AppLog.Line("Socket::CloseSocket() - Closed");
	}
}

void Socket::CloseSocketS1(void)
{
	if(s1){
		int rc = closesocket(s1);
		s1 = 0;
	}
}

//zisti cislo portu - podla pozadovanej sluzby +
//+ zisti IP adresu adresa podla mena
int Socket::Set_sockaddr_in(const char* host, const char* service, const char* protocol, sockaddr_in* si)
{
	struct servent *pse;
	struct hostent *phe;
	
	memset(si, 0, sizeof(sockaddr_in));
	si->sin_family = AF_INET;
	//zisti cislo portu - podla pozadovanej sluzby
	if(service){
		if((pse = getservbyname(service, protocol)) != 0)
			si->sin_port = pse->s_port;
		else if((si->sin_port = htons((u_short)atoi(service))) == 0){
			//chyba=WSAGetLastError();
			return CHYBA;//chyba
		}
	}
	
	//zisti IP adresu
	//adresa podla mena
	if(host){
		if((host[0]<'0' || host[0]>'9') && ((phe = gethostbyname(host)) != 0)){
			memcpy(&si->sin_addr, phe->h_addr, phe->h_length);
			//adresa podla cisla
		}else if((si->sin_addr.s_addr = inet_addr(host)) == INADDR_NONE){
			//chyba=WSAGetLastError();
			return CHYBA;//chyba
		}
	}
	return OK;
}

//TCP/IP support
//pocka na pripojenie na socket, host je localhost
SOCKET Socket::WaitSock(const char *host,const char *service, const char *protocol, int backlog)
{
	struct sockaddr_in si;
	struct protoent *ppe;
	SOCKET s;
	int type;
	//int rc;

	//zisti cislo portu - podla pozadovanej sluzby +
	//+ zisti IP adresu adresa podla mena
	if(Set_sockaddr_in(host, service, protocol, &si))
		return 0;

	//zisti cislo protokolu - TCP alebo UDP
	if((ppe=getprotobyname(protocol))==0)
		return 0;//chyba
	if(lstrcmp((LPCWSTR)protocol,(LPCWSTR)"udp")==0)
		type=SOCK_DGRAM;
	else
		type=SOCK_STREAM;
	//vytvori socket
	s=socket(PF_INET,type,ppe->p_proto);
	if(s==INVALID_SOCKET)
		return 0;//chyba, nemozno vytvorit socket

	//adresa
	if( bind(s,(const struct sockaddr *)&si, sizeof(si)) != 0)
	{
	    return 0;
	}
	//pasivny mod socketu
	if(listen(s,backlog)!=0){
	    return 0;
	}
	return s;
}

//caka na spojenie, kym sa nepripoji klient pomocou tcp
SOCKET Socket::WaitTCP(const char *host,const char *service, int backlog)
{
	return WaitSock(host,service,"tcp", backlog);
}

//caka na spojenie, kym sa nepripoji klient pomocou udp
SOCKET Socket::WaitUDP(const char *host,const char *service, int backlog)
{
	return WaitSock(host,service,"udp", backlog);
}

//caka, sprva sa ako server
int Socket::Wait(const char *cPort, const char *cAddress, int backlog)
{
	
//	try{
		s1=WaitTCP(cAddress, cPort, backlog);
/*
		s=accept(s1,NULL,NULL);
		if(s==INVALID_SOCKET){
			//chyba pri pripajani
			s=0;
			rc=CHYBA;
			throw 1;
		}
*/
		if(!s1)
			return WSAGetLastError();
		else 
			return OK;
//		throw 2;
//	}
//	catch(int){
		//zhodim socket s1
//		CloseSocketS1();
//		return rc;
//	}
}

int Socket::Accept(sockaddr_in *sa_in)
{
	int rc;
	int size = sizeof(sockaddr_in);
	ZeroMemory(sa_in,size);
	sa_in->sin_family = AF_INET;
	try{
	    if(sa_in)
			s=accept(s1,(sockaddr *) sa_in, &size);
		else
			s=accept(s1, NULL, NULL);

		if(s==INVALID_SOCKET){
			//chyba pri pripajani
			s=0;
			rc=WSAGetLastError();
			throw 1;
		}
		// The ntohs function converts a u_short from TCP/IP network byte order 
		// to host byte order (which is little-endian on Intel processors).
		sa_in->sin_port = ntohs(sa_in->sin_port);
		rc=OK;
		return rc;
	}
	catch(int){
		//zhodim socket s1
		CloseSocketS1();
		return rc;
	}
}

//pripoji socket na adresu a port pomocou protokolu (TCP alebo UDP)
SOCKET Socket::ConnectSock(const char *host, const char *service, const char *localhost, const char *localservice, const char *protocol)
{
	struct sockaddr_in si;
	struct protoent *ppe;
	SOCKET sock;
	int type;

	//zisti cislo portu - podla pozadovanej sluzby +
	//+ zisti IP adresu adresa podla mena
	if(Set_sockaddr_in(host, service, protocol, &si))
		return 0;

	//zisti cislo protokolu - TCP alebo UDP
	if((ppe=getprotobyname(protocol))==0){
		//chyba=WSAGetLastError();
		return 0;//chyba
	}
	if(lstrcmp((LPCWSTR)protocol,(LPCWSTR)"udp")==0)
		type=SOCK_DGRAM;
	else
		type=SOCK_STREAM;
	//vytvori socket
	sock = socket(PF_INET,type,ppe->p_proto);
	if(sock < 0){
		//chyba=WSAGetLastError();
		return 0;//chyba, nemozno vytvorit socket
	}

	//chcem nastavit konkretnu lokalnu adresu (napr. ak mam viac sietoviek)
	if(localhost || localservice){
		sockaddr_in si_local;
		if(!Set_sockaddr_in(localhost, localservice, protocol, &si_local)){
			if(bind(sock, (sockaddr*)&si_local, sizeof(si_local))){
				//Mam sa nepripojit ??? Sak sa iba nepodarilo nastavit local address ..
				int err = WSAGetLastError();
				closesocket(sock);
				WSASetLastError(err);
				return 0;
			}
		}
	}
	//Urob konecne connect
	if(connect(sock,(const struct sockaddr *)&si,sizeof(si))!=0)
	{
		int chyba=WSAGetLastError();
		closesocket(sock);
		return 0;//nemoze sa spojit
	}
	return sock;
}

//pripoji sa na adresu a port pomocou tcp
SOCKET Socket::ConnectTCP(const char *host,const char *service, const char *localhost, const char *localservice)
{
	return ConnectSock(host, service, localhost, localservice, "tcp");
}

//pripoji sa na adresu a port pomocou udp
SOCKET Socket::ConnectUDP(const char *host, const char *service, const char *localhost, const char *localservice)
{
	return ConnectSock(host, service, localhost, localservice, "udp");
}

int Socket::Connect(const char *cAddress,const char *cPort, const char *cLocalAddress, const char *cLocalPort)
{
	s=ConnectTCP(cAddress, cPort, cLocalAddress, cLocalPort);
	if(!s || s==SOCKET_ERROR){
		s=0;
		return WSAGetLastError();//nemozno sa pripojit
	}
	return OK;
}

//zapise na vystup data
int Socket::Send(void *data, int iPocet)
{
	if(!s){
		return WSAENOTSOCK;//neinicializovany socket
	}
	if(!iPocet){
		return OK;
	}
	try{
		if(send(s, (const char *)data, iPocet, 0)==SOCKET_ERROR){
			return WSAGetLastError();
		}
	}
	catch(...){
		return WSAGetLastError();
	}
	return OK;
}

//cita zo vstupu data
int Socket::Recv(void *data, int& iPocet, DWORD dwTimeout)
{
	if(!s){
		return WSAENOTSOCK;//neinicializovany socket
	}
	int rc;
	FD_SET readfds;
	readfds.fd_count=1;
	readfds.fd_array[0]=s;
	timeval tv;
	tv.tv_sec=dwTimeout/1000;
    tv.tv_usec=(dwTimeout-tv.tv_sec*1000)*1000;
	rc=select(0,&readfds,NULL,NULL,&tv);
	if(rc==1)
	{
		rc=recv(s, (char *)data, iPocet, 0);//prijme text
		if(rc==0)
		{
			CloseSocketS();//druha strana zhodila spojenie
			return WSAENOTCONN;
		}

		if(rc==SOCKET_ERROR)
		{
			rc = WSAGetLastError();
			CloseSocketS();//druha strana zhodila spojenie
			iPocet = 0;
			return rc;//spadnuty socket
		}

		iPocet = rc;
		return OK;
	}
	else if(rc==SOCKET_ERROR)
	{
		rc = WSAGetLastError();
		CloseSocketS();//druha strana zhodila spojenie
		iPocet = 0;
		return rc;//spadnuty socket
	}

	rc = WSAGetLastError();
	iPocet = 0;
	return OK;
}

