/************************************************************************/
/* Trieda zapuzdrujuca pracu so socket-mi (TCP, UDP protokoly).			*/
/*																		*/
/* 																		*/
/* Autor: Marek Pavlovic												*/
/* Datum: ??. ??. 199?													*/
/* Upravil: Marek Timko v r. 2002										*/
/************************************************************************/
#pragma once

#include <winsock2.h>

class Socket {
	static int init;	
public:
	SOCKET s1;
	static void InitSockets(void);//inicializuje pripojenie WinSock dll kniznice
	SOCKET s;
	Socket(Socket *s);
	Socket(void);
	virtual ~Socket();
	//pripoji sa k serveru
	int Connect(const char *cAddress,const char *cPort, const char *cLocalAddress = NULL, const char *cLocalPort = NULL);
	//caka na zavolanie, az potom sa vrati
	//ak je adresa null, tak caka na vsetkych interface
	int Wait(const char *cPort,const char *cAddress = NULL, int backlog = 2/*SOMAXCONN je max*/);
	int Accept(sockaddr_in *sa = NULL);//po wait, caka na prichadzajuce spojenie
	//zapise na vystup data
	// iPocet - pocet bytov
	int Send(void *da, int iPocet);
	//cita zo vstupu data, timeout v ms
	int Recv(void *da,int& iPocet, DWORD dwTimeout = 100);
	void CloseSocketS();
	void CloseSocketS1();
	static int FreeSockets(void);//uvolni DLL z pamate

private:
	SOCKET WaitSock(const char *host, const char *service, const char *protocol, int backlog);
	SOCKET WaitTCP(const char *host, const char *service, int backlog);
	SOCKET WaitUDP(const char *host, const char *service, int backlog);
	SOCKET ConnectSock(const char *host, const char *service, const char *localhost, const char *localservice, const char *protocol);
	SOCKET ConnectTCP(const char *host, const char *service, const char *localhost, const char *localservice);
	SOCKET ConnectUDP(const char *host, const char *service, const char *localhost, const char *localservice);
	//zisti cislo portu - podla pozadovanej sluzby +
	//+ zisti IP adresu adresa podla mena
	int Set_sockaddr_in(const char* host, const char* service, const char *protocol, sockaddr_in* si);
};
