// TCP_ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TCP_Client.h"
#include "TCP_ClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTCP_ClientDlg dialog




CTCP_ClientDlg::CTCP_ClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTCP_ClientDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTCP_ClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTCP_ClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTONCONNECT, &CTCP_ClientDlg::OnBnClickedButtonconnect)
	ON_MESSAGE(MSG_SERVER_DOWN, OnServerDown)
	ON_MESSAGE(MSG_SERVER_UP, OnServerUp)
	ON_MESSAGE(MSG_NEW_DATA, OnNewData)
	ON_BN_CLICKED(IDC_BUTTONSEND, &CTCP_ClientDlg::OnBnClickedButtonsend)
	ON_BN_CLICKED(IDC_BUTTONDISCONNECT, &CTCP_ClientDlg::OnBnClickedButtondisconnect)
END_MESSAGE_MAP()


// CTCP_ClientDlg message handlers

BOOL CTCP_ClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	client = new Client(this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTCP_ClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTCP_ClientDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTCP_ClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTCP_ClientDlg::OnBnClickedButtonconnect()
{
	client->StartTCPClient();

	CButton *pButton = (CButton *)GetDlgItem(IDC_BUTTONCONNECT);
	pButton->EnableWindow(false);

	pButton = (CButton *)GetDlgItem(IDC_BUTTONDISCONNECT);
	pButton->EnableWindow(true);

	pButton = (CButton *)GetDlgItem(IDC_BUTTONSEND);
	pButton->EnableWindow(true);


}

LRESULT CTCP_ClientDlg::OnServerDown(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Chyba spojenia alebo je server vypnut.\r\n");

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ClientDlg::OnServerUp(WPARAM wParam, LPARAM lParam)
{	
	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Pripojenie sa server spen.\r\n");

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ClientDlg::OnNewData(WPARAM wParam, LPARAM lParam)
{
	char cData[1024];
	client->GetSocketBuffer(cData, sizeof(cData));

	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Odpove od servera: [%s]\r\n", cData);

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}



void CTCP_ClientDlg::OnBnClickedButtonsend()
{
	char cTextBuffer[1024];
	memset(cTextBuffer, 0, sizeof(cTextBuffer));

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDITSEND);
	pEdit->GetWindowText(cTextBuffer, sizeof(cTextBuffer));
	client->SendData(cTextBuffer, strlen(cTextBuffer));
}

void CTCP_ClientDlg::OnBnClickedButtondisconnect()
{	
	client->StopTCPClient();

	CButton *pButton = (CButton *)GetDlgItem(IDC_BUTTONCONNECT);
	pButton->EnableWindow(true);

	pButton = (CButton *)GetDlgItem(IDC_BUTTONDISCONNECT);
	pButton->EnableWindow(false);

	pButton = (CButton *)GetDlgItem(IDC_BUTTONSEND);
	pButton->EnableWindow(false);
}
