#include "stdafx.h"
#include "Server.h"

Server::Server(CDialog *dialog)
{	
	this->dialog = dialog;

	hServerStop = CreateEvent(NULL, FALSE, FALSE, NULL);	

	WORD wVersionRequested;
	WSADATA wsaData;
	wVersionRequested = MAKEWORD(2,0);

	//INICIALIZUJEME WISOCK DLL. AK JE NEINICIALIZOVANA NEFUNGUJU FUNKCIE AKO 'getprotobyname' A POD.
	if(WSAStartup( wVersionRequested, &wsaData ) != 0)
	{
		MessageBoxA(dialog->m_hWnd, "Chyba inicializcie 'Winsock DLL' ", "CHYBA", MB_OK);		
	}		
}

Server::~Server()
{	
	CloseHandle(hServerStop);	
}

void Server::StartTCPServer()
{	
	//VYTVORIME VLAKNO KTORE BUDE POCUVAT NA PORTE. SPUSTI SA STATICKA FUNKCIA 'StartThread'
	hListenThread =(HANDLE)_beginthread(this->StartThread, 0, this);	
}

void Server::StopTCPServer()
{	
	SetEvent(hServerStop);	
}

void Server::StartThread(void *ts)
{
	//SPUSTIME FUNKCIU 'ListenOnPort' KTORA MA "NEKONECNY" CYKLUS while()
	Server *server = (Server *)ts;
	server->ListenOnPort();
}

int Server::Set_sockaddr_in(const char* host, const char* service, const char* protocol, sockaddr_in* si)
{
	struct servent *pse;
	struct hostent *phe;
	
	memset(si, 0, sizeof(sockaddr_in));
	si->sin_family = AF_INET;
	
	if(service)
	{
		if((pse = getservbyname(service, protocol)) != 0)
			si->sin_port = pse->s_port;
		else if((si->sin_port = htons((u_short)atoi(service))) == 0)
		{			
			return 1;//chyba
		}
	}
	
	if(host){
		if((host[0]<'0' || host[0]>'9') && ((phe = gethostbyname(host)) != 0))
		{
			memcpy(&si->sin_addr, phe->h_addr, phe->h_length);
			
		}
		else if((si->sin_addr.s_addr = inet_addr(host)) == INADDR_NONE)
		{
			
			return 1;//chyba
		}
	}
	return 0;
}

SOCKET Server::Listen(const char *host,const char *service, int backlog)
{
	struct sockaddr_in si;
	struct protoent *ppe;
	SOCKET sock;
	
	//NAPLNIME SI STRUKTURU 'si' PODLA ZADANEEJ ADRESY A PORTU
	if(Set_sockaddr_in(host, service, "tcp", &si))
		return NULL;
	
	//ZISTIME CISLO PROTOKOLU 'tcp'
	if((ppe = getprotobyname("tcp"))==0)
		return NULL;//chyba
	
	//VYTVORIME SOCKET, KTORYM BUDEME NACUVAT NA PRIPOJENIA
	sock = socket(PF_INET, SOCK_STREAM, ppe->p_proto);

	if(sock == INVALID_SOCKET)
		return NULL;
	
	//NAVIAZEME SOCKET NA ADRESU A PORT
	if( bind(sock, (const struct sockaddr *)&si, sizeof(si)) != 0)
	{
	    return NULL;
	}

	//SPUSTIME MOD POCUVANIA NA ADRESE A PORTE
	if(listen(sock, backlog)!=0)
	{
	    return NULL;
	}

	return sock;
}

SOCKET Server::Accept(sockaddr_in *sa_in)
{
	SOCKET sock;	
	int size = sizeof(sockaddr_in);
	ZeroMemory(sa_in,size);
	sa_in->sin_family = AF_INET; //BUDEME POUZIVAT IP ADRESY TYPU 'IPv4' 
	try
	{
		//AK JE SMERNIK NA 'sa_in' STRUKTURU != NULL 
		//TAK ZAVOLAME ACCEPT A POSLEME AKO PARAMETER 'sa_in' STRUKTURU, KTORU NAM 'accept' VYPLNI,
		//A V KTOREJ BUDEME MAT 'ip adresu' KLIENTA, KTORY SA PRIPOJIL
	    if(sa_in) 
			sock = accept(socketListen,(sockaddr *) sa_in, &size);
		else
			sock = accept(socketListen, NULL, NULL);

		if(sock == INVALID_SOCKET) //NEPODARILO SA AKCEPTOVAT KLIENTOVO PRIPOJENIE
		{			
			sock = NULL;		
			return NULL;
		}

		sa_in->sin_port = ntohs(sa_in->sin_port);
				
		//AK SME USPESNE PRIJALI KLIENTOVO SPOJENIE VRATIME NOVOVYTVORENY KOMUNIKACNY SOCKET 
		//NA KTOROM BUDE SERVER S KLIENTOM KOMUNIKOVAT
		return sock;		
	}
	catch(int)
	{
		return NULL;
	}
}


void Server::ListenOnPort()
{		
	//NACITAME SI Z DIALOGU IP ADRESU (AK JE VIAC SIETOVIEK) A PORT NA KTOROM SA MA SPUSTIT SERVER
	CEdit *pAddress = (CEdit *)(dialog->GetDlgItem(IDC_IPADDRESS));
	CEdit *pPort = (CEdit *)(dialog->GetDlgItem(IDC_PORT));

	char cIpAddress[16];
	char cPort[6];
	pAddress->GetWindowText(cIpAddress, sizeof(cIpAddress));
	pPort->GetWindowText(cPort, sizeof(cPort));

	if(strlen(cIpAddress) == 0)
	{
		MessageBoxA(dialog->m_hWnd, "IP adresa nie je vyplnen.\nPouije sa 127.0.0.1", "CHYBA", MB_OK);		
		sprintf(cIpAddress, "127.0.0.1");
		pAddress->SetWindowText(cIpAddress);
	}

	if(strlen(cPort) == 0)
	{
		MessageBoxA(dialog->m_hWnd, "Port nie je vyplnen.\nPouije sa 7777", "CHYBA", MB_OK);		
		sprintf(cPort, "7777");
		pPort->SetWindowText(cPort);
	}

	ResetEvent(hServerStop);

	socketListen = this->Listen(cIpAddress, cPort , 10); //SPUSTIME NACUVANIE NA PORTE

	SendMessage(dialog->m_hWnd, MSG_SERVER_STARTED, NULL, NULL); //DAJ VEDIET DIALOGU ZE SA SERVER SPUSTIL

	FD_ZERO(&fdClientsSet);
	FD_SET(socketListen, &fdClientsSet);

	//VYTVORIME SI 'sockaddr_in' STRUKTURU, V KTOREJ BUDEME DOSTAVAT INFO
	//O PRIPAJAJUCICH SA KLIENTOCH (IP ADRESA A POD.)
	sockaddr_in sa; 

	timeval tv;
	tv.tv_sec = 0;
	tv.tv_usec = 300000; //TIMEOUT INTERVAL PRE 'select' FUNKCIU
	
	char cMessage[250];
	char buffer[1024];

	SOCKET socketAccept;
	

	while( WaitForSingleObject( hServerStop, 0 ) == WAIT_TIMEOUT )
	{			
		//select VRATI IBA SOCKETY KTORE NIECO SIGNALIZUJU PRETO SWI VZDY SPRAVIME KOPIU 'fdCheckingSet' 
		//ZO SADY ZNAMKYCH KLIENTOV 'fdClientsSet' V KTOREJ JE AJ LISTENOVACI SOCKET
		memcpy(&fdCheckingSet, &fdClientsSet, sizeof(fdCheckingSet));

		select(0,  &fdCheckingSet, NULL, NULL, &tv); //KONTROLUJ SOCKETY KAZDYCH 300 MILISEKUND		
		//SELECT VRATI IBA SIGNALIZOVANE SOCKETY

		if(fdCheckingSet.fd_count == 0) //NIKTO NIC NESIGNALIZUJE ? => NEROBIME NIC
			continue;

		if( FD_ISSET(socketListen, &fdCheckingSet) ) //SIGNALIZUJE LISTEN-SOCKET ? => NIEKTO SA CHCE PRIPOJIT	
		{
			if( (socketAccept = this->Accept(&sa)) == NULL ) //AKCEPTUJEME SPOJENIE 
			{
				MessageBoxA(dialog->m_hWnd, "Socket accept error !!!", "CHYBA", MB_OK);		
			}
			else			
			{						
				AddClient(socketAccept); //PRIDAME KLIENTA DO SADY
				SendMessage(dialog->m_hWnd, MSG_CLIENT_ACCEPTED, (WPARAM)socketAccept, NULL);	//DAME VEDIET DIALOGU ZE SA PRIPOJIL NOVY KLIENT			
			}			
		}

		for(int i=0; i < fdCheckingSet.fd_count; i++) //PREJDI VSETKY SOCKETY - (KLIENTOV)
		{
			if(fdCheckingSet.fd_array[i] != socketListen) //CITAJ VSETKY OKREM LISTENOVACIEHO SOCKETU
			{
				int iReceivedBytes = recv(fdCheckingSet.fd_array[i], buffer, sizeof(buffer), 0);

				if(iReceivedBytes == SOCKET_ERROR || iReceivedBytes == 0) //CHYBA NA SOCKETE == 'SOCKET_ERROR' ALEBO ODPOJENIE KLIENTA == '0' 
				{		
					RemoveClient(fdCheckingSet.fd_array[i]); //ODSTRAN HO ZO SADY KLIENTOV KTORU KONTROLUEME NA UDALOSTI

					SendMessage(dialog->m_hWnd, MSG_CLIENT_DISCONNECTED, (WPARAM)fdCheckingSet.fd_array[i], NULL);	//DAJ VEDIET DIALOGU O ODPOJENI KLIENTA									
				}	
				else
				{
					//VYTVOR LOKALNY BUFFER
					char cIncommingData[1024];
					memset(cIncommingData, 0, sizeof(cIncommingData));

					//PREKOPIRUJ DATA KTORE NACITAL 'recv' ZO SOCKETU DO LOKALNEHO BUFFERA
					memcpy(cIncommingData, buffer, sizeof(cIncommingData));					

					//DAJ VEDIET DIALOGU ZE PRISLI DATA
					SendMessage(dialog->m_hWnd, MSG_DATA_RECEIVED, (WPARAM)fdCheckingSet.fd_array[i], NULL);										

					//UROB OBRATENY TEXT
					char cReverseData[1024];
					memset(cReverseData, 0, sizeof(cReverseData));
					
					for(int i = 0; i < iReceivedBytes; i++)
						cReverseData[iReceivedBytes - 1 - i] = cIncommingData[i];					
					//END - UROB OBRATENY TEXT
					
					//POSLI KLIENTOVI OBRATENY TEXT
					int iBytesSend = send(fdCheckingSet.fd_array[i], cReverseData, iReceivedBytes, 0);					

					if(iBytesSend == SOCKET_ERROR) //NASTALAQ CHYBA PRI POSIELANI (KLIENT SPADOL APOD.)
						RemoveClient(fdCheckingSet.fd_array[i]); //ODSTRANIME HO ZO SADY KTORU KONTROLUJEME					
				}

			}
		}				
	}
	
	//VLAKNO BOLO TLACIDLOM 'STOP' UKONCENE ...ZAVRIEME VSETKY SOCKETY
	for(int i=0; i < fdClientsSet.fd_count; i++)
		closesocket(fdClientsSet.fd_array[i]);

	SendMessage(dialog->m_hWnd, MSG_SERVER_STOPPED, NULL, NULL); //DAME VEDIET DIALOGU ZE BOL SERVER STOPNUTY
}

void Server::AddClient(SOCKET client)
{
	FD_SET(client, &fdClientsSet); //PRIDAME KLIENTA DO SADY SOCKETOV KTORE KONTROLUJEME
}

void Server::RemoveClient(SOCKET client)
{
	FD_CLR(client, &fdClientsSet); //ODSTRANIME KLIENTA DO SADY SOCKETOV KTORE KONTROLUJEME
	closesocket(client);	//ZAVRIEME SOCKET
}

