// TCP_ServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TCP_Server.h"
#include "TCP_ServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTCP_ServerDlg dialog




CTCP_ServerDlg::CTCP_ServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTCP_ServerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTCP_ServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTCP_ServerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RUN, &CTCP_ServerDlg::OnBnClickedRun)
	ON_MESSAGE(MSG_CLIENT_ACCEPTED, OnNewClientAccepted)
	ON_MESSAGE(MSG_CLIENT_DISCONNECTED, OnClientDisconnected)
	ON_MESSAGE(MSG_DATA_RECEIVED, OnClientDataRecevied)			
	ON_MESSAGE(MSG_SERVER_STARTED, OnServerStart)			
	ON_MESSAGE(MSG_SERVER_STOPPED, OnServerStop)			
	ON_BN_CLICKED(IDC_STOP, &CTCP_ServerDlg::OnBnClickedStop)
END_MESSAGE_MAP()


// CTCP_ServerDlg message handlers

BOOL CTCP_ServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//Vytovrime si objekt "Server", ktory spusta vlakno a pocuva na porte
	server = new Server(this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTCP_ServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTCP_ServerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTCP_ServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTCP_ServerDlg::OnBnClickedRun()
{
	server->StartTCPServer();	


	CButton *pButton = (CButton *)GetDlgItem(IDC_RUN);	
	pButton->EnableWindow(false);

	pButton = (CButton *)GetDlgItem(IDC_STOP);
	pButton->EnableWindow(true);
}

LRESULT CTCP_ServerDlg::OnNewClientAccepted(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[100];
	sprintf(cTextBuffer, "Klient .%d sa pripojil\r\n", (int)wParam);

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ServerDlg::OnClientDisconnected(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[100];
	sprintf(cTextBuffer, "Klient .%d sa odpojil\r\n", (int)wParam);

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ServerDlg::OnClientDataRecevied(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Klient .%d poslal dta\r\n", (int)wParam );

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ServerDlg::OnServerStart(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Server spusten\r\n");

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}

LRESULT CTCP_ServerDlg::OnServerStop(WPARAM wParam, LPARAM lParam)
{
	char cTextBuffer[1024];
	sprintf(cTextBuffer, "Server zastaven\r\n");

	CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EVENTS);
	int iLength = pEdit->GetWindowTextLengthA();
	pEdit->SetSel(iLength, iLength);
	pEdit->ReplaceSel(cTextBuffer);
	
	return 0;
}



void CTCP_ServerDlg::OnBnClickedStop()
{
	server->StopTCPServer();

	CButton *pButton = (CButton *)GetDlgItem(IDC_RUN);	
	pButton->EnableWindow(true);

	pButton = (CButton *)GetDlgItem(IDC_STOP);
	pButton->EnableWindow(false);
}


